rollout quasiCrystals2_addrule "quasiCrystals2 - Add rule" width:548 height:300
			(
				global user_expr = "_i"
				
				radiobuttons rbt_axis "Axis:" labels:#("X", "Y", "Z","User defined") columns:4 width:300
				radiobuttons rbt_transform "Transform:" labels:#("Move", "Rotate", "Scale","User defined") columns:4 width:300
				label lbl1 " "
				label lbl2 " '_item' - current item being iterated, '_i' - current iteration integer "
				edittext edt_expr "Expression:" width:500
				label lbl3 " "
				
				edittext edt_custom "User defined:" height:88 width:500 visible:false
				
				button btn_add "Add rule"
				button btn_close "Close"
				
				fn updateExpression=
				(
					local axis=1
					local tran=1
					local custom=""
					local expr="_item"
					
					axis = rbt_axis.state
					tran = rbt_transform.state
					
					if (tran==1) then expr += ".pos"
					if (tran==2) then expr += ".rot"
					if (tran==3) then expr += ".scale"
					
					if (axis==1) then expr += ".x"
					if (axis==2) then expr += ".y"
					if (axis==3) then expr += ".z"
					
					expr += (" = " + user_expr)
					
					edt_expr.text = expr
				)
				
				on rbt_axis changed state do updateExpression()
				on rbt_transform changed state do updateExpression()
				on edt_expr changed arg do
				(
					local temp_expr = filterString edt_expr.text "="
					user_expr = temp_expr[temp_expr.count]
					
					--updateExpression()
				)
				
				on edt_expr entered arg do
				(
					/*local user_expr = filterString edt_expr.text "="
					user_expr = user_expr[user_expr.count]
					
					updateExpression()*/
					local temp_rules = #()
					join temp_rules quasiCrystals2.lbx_rules.items
					append temp_rules edt_expr.text
					quasiCrystals2.lbx_rules.items = temp_rules
					quasiCrystals2.lbx_rules.selection = quasiCrystals2.lbx_rules.items.count
				)
				
				on btn_close pressed do destroydialog quasiCrystals2_addrule
					
				on btn_add pressed do
				(
					local temp_rules = #()
					join temp_rules quasiCrystals2.lbx_rules.items
					append temp_rules edt_expr.text
					quasiCrystals2.lbx_rules.items = temp_rules
					quasiCrystals2.lbx_rules.selection = quasiCrystals2.lbx_rules.items.count
				)
				
				on quasiCrystals2_addrule open do
				(
					updateExpression()
				)
			)
			createdialog quasiCrystals2_addrule