fn getParsedStr str=
	(
		local new_str = substituteString str "\"" "\\\""
		return new_str
	)
	fn create_ui_register_globals curr_tool=
	(
		local ui_controls = ""
		ui_controls += "global subRolloutCtrl_"+curr_tool.id+" \n"
		return ui_controls
	)
	fn create_ui_cotrols_for curr_tool j show_num num=
	(
		local ui_controls = ""
	local ui_add_later = ""
	local handlers_count = 0
		if(show_num)then
			num = (num as string)+". "
		else num=""
		--ui_controls += "global subRolloutCtrl_"+curr_tool.id+" \n"
		ui_controls += "rollout subRolloutCtrl_"+curr_tool.id+" \""+(num)+""+(curr_tool.name)+"\" \n"
		ui_controls += "(\n"
		
		is_enabled = "true"
		if(curr_tool.adv_setts.locked) do is_enabled = "false"
		for i=1 to curr_tool.vars.count do
			(
				local c_var = curr_tool.vars[i]
				local currid = (curr_tool.id+"_"+(c_var.name)+"_"+(i as string))
				-- edittext
				if (c_var.handler == 2 AND (c_var.use ==true OR c_var.use=="true"))do
				(
					handlers_count += 1
					if (santexToolbox_ui_show_ctrl_captions)do(
					if (c_var.caption!="$")then
						ui_controls += "label lbl_caption_"+currid+" \""+(handlers_count as string)+". "+(c_var.caption)+":\" align:#left \n"
					else ui_controls += "label lbl_caption_"+currid+" \""+(handlers_count as string)+". <Edittext (Expression)>:\" align:#left \n"
					)
					ui_controls += "edittext edt_"+currid+" \""+(c_var.name)+" = \" height:"+(santexToolbox_ui_ctrl_edittext_height as string)+" labelOnTop:false tooltip:\""+(c_var.caption)+"\" enabled:"+(is_enabled as string)+"\n"
					if (santexToolbox_ui_show_ctrl_captions)do ui_controls += "label lbl0_"+currid+" \"\" \n"
					ui_add_later += ("edt_"+currid+".text=\""+(getParsedStr (c_var.value as string))+"\" \n")
					ui_controls += "on edt_"+currid+" changed val do\n(\n"
					ui_controls += "all_toolsets[santexToolbox.ddl_toolset.selection].tools["+(j as string)+"].vars["+(i as string)+"].value=val"
					ui_controls += " )\n"
				)
				
				-- spinner integer
				if (c_var.handler == 3 AND (c_var.use ==true OR c_var.use=="true"))do
				(
					handlers_count += 1
					
					if (santexToolbox_ui_show_ctrl_captions)do(
					if (c_var.caption!="$")then
						ui_controls += "label lbl_caption_"+currid+" \""+(handlers_count as string)+". "+(c_var.caption)+":\" align:#left \n"
					else ui_controls += "label lbl_caption_"+currid+" \""+(handlers_count as string)+". <Spinner (Integer value)>:\" align:#left \n"
					)
					ui_controls += "spinner spn_"+currid+" \""+(c_var.name)+" = \" fieldwidth:80 align:#center type:#integer range:[-999999,999999,1] tooltip:\""+(c_var.caption)+"\" enabled:"+(is_enabled as string)+"\n"
					if (santexToolbox_ui_show_ctrl_captions)do ui_controls += "label lbl0_"+currid+" \"\" \n"
					ui_add_later += ("spn_"+currid+".value="+(c_var.value as string)+" \n")
					ui_controls += "on spn_"+currid+" changed val do\n(\n"
					ui_controls += "all_toolsets[santexToolbox.ddl_toolset.selection].tools["+(j as string)+"].vars["+(i as string)+"].value=val"
					ui_controls += " )\n"
				)
				
				-- spinner float
				if (c_var.handler == 4 AND (c_var.use ==true OR c_var.use=="true"))do
				(
					handlers_count += 1
					
					if (santexToolbox_ui_show_ctrl_captions)do(
					if (c_var.caption!="$")then
						ui_controls += "label lbl_caption_"+currid+" \""+(handlers_count as string)+". "+(c_var.caption)+":\" align:#left \n"
					else ui_controls += "label lbl_caption_"+currid+" \""+(handlers_count as string)+". <Spinner (Float value)>:\" align:#left \n"
					)
					ui_controls += "spinner spn_"+currid+" \""+(c_var.name)+" = \" fieldwidth:80 align:#center type:#float range:[-999999,999999,1] tooltip:\""+(c_var.caption)+"\" enabled:"+(is_enabled as string)+"\n"
					if (santexToolbox_ui_show_ctrl_captions)do ui_controls += "label lbl0_"+currid+" \"\" \n"
					ui_add_later += ("spn_"+currid+".value="+(c_var.value as string)+" \n")
					ui_controls += "on spn_"+currid+" changed val do\n(\n"
					ui_controls += "all_toolsets[santexToolbox.ddl_toolset.selection].tools["+(j as string)+"].vars["+(i as string)+"].value=val"
					ui_controls += " )\n"
				)
				
				-- pickbutton
				if (c_var.handler == 5 AND (c_var.use ==true OR c_var.use=="true"))do
				(
					handlers_count += 1
					
					if (santexToolbox_ui_show_ctrl_captions)do(
					if (c_var.caption!="$")then
						ui_controls += "label lbl_caption_"+currid+" \""+(handlers_count as string)+". "+(c_var.caption)+":\" align:#left \n"
					else ui_controls += "label lbl_caption_"+currid+" \""+(handlers_count as string)+". <Pickbutton (Scene node)>:\" align:#left enabled:"+(is_enabled as string)+"\n"
					)
					ui_controls += "pickbutton btn_"+currid+" \"\" width:100 align:#center tooltip:\""+((c_var.name))+" = \" \n"
					if (santexToolbox_ui_show_ctrl_captions)do ui_controls += "label lbl0_"+currid+" \"\" \n"
					ui_add_later += ("btn_"+currid+".text=\"Pick scene node\" \n")
					ui_controls += "on btn_"+currid+" picked _scn_obj do\n(\n"
					ui_controls += "btn_"+currid+".text=_scn_obj.name \n"
					ui_controls += "txt=\""+(c_var.name)+" = \"+_scn_obj as string \n"
					ui_controls += "btn_"+currid+".tooltip=txt \n"
					ui_controls += "global "+(c_var.name)+"=_scn_obj \n"
					ui_controls += ")\n"
				)
				
				-- checkbox boolean
				if (c_var.handler == 6 AND (c_var.use ==true OR c_var.use=="true"))do
				(
					handlers_count += 1
					
					if (santexToolbox_ui_show_ctrl_captions)do(
					if (c_var.caption!="$")then
						ui_controls += "label lbl_caption_"+currid+" \""+(handlers_count as string)+". "+(c_var.caption)+":\" align:#left \n"
					else ui_controls += "label lbl_caption_"+currid+" \""+(handlers_count as string)+". <Checkbox (Boolean value)>:\" align:#left \n"
					)
					
					if (c_var.value==true OR c_var.value=="true")then
						ui_controls += "checkbox chk_"+currid+" \""+(c_var.name)+" = TRUE\" align:#center checked:true tooltip:\""+(c_var.caption)+"\" enabled:"+(is_enabled as string)+"\n"
					else
						ui_controls += "checkbox chk_"+currid+" \""+(c_var.name)+" = FALSE\" align:#center checked:false tooltip:\""+(c_var.caption)+"\" enabled:"+(is_enabled as string)+"\n"
					if (santexToolbox_ui_show_ctrl_captions)do ui_controls += "label lbl0_"+currid+" \"\" \n"
					ui_controls += "on chk_"+currid+" changed val do\n(\n"
					ui_controls += "if(val)then chk_"+currid+".text=\""+(c_var.name)+" = TRUE\" else chk_"+currid+".text=\""+(c_var.name)+" = FALSE\" \n"
					ui_controls += "all_toolsets[santexToolbox.ddl_toolset.selection].tools["+(j as string)+"].vars["+(i as string)+"].value=val"
					ui_controls += " )\n"
				)
				
				-- custom
				if (c_var.handler == 7 AND (c_var.use ==true OR c_var.use=="true"))do
				(
					handlers_count += 1
					
					if (santexToolbox_ui_show_ctrl_captions)do(
					if (c_var.caption!="$")then
						ui_controls += "label lbl_caption_"+currid+" \""+(handlers_count as string)+". "+(c_var.caption)+":\" align:#left \n"
					else ui_controls += "label lbl_caption_"+currid+" \""+(handlers_count as string)+". <Custom>:\" align:#left \n"
					)
					/*
					if (c_var.value==true OR c_var.value=="true")then
						ui_controls += "checkbox chk_"+currid+" \""+(c_var.name)+" = TRUE\" align:#center checked:true\n"
					else
						ui_controls += "checkbox chk_"+currid+" \""+(c_var.name)+" = FALSE\" align:#center checked:false\n"
					*/
					ui_controls += c_var.custom_handler + "\n"
					if (santexToolbox_ui_show_ctrl_captions)do ui_controls += "label lbl0_"+currid+" \"\" \n"
					--ui_controls += "on chk_"+currid+" changed val do\n(\n"
					--ui_controls += "if(val)then chk_"+currid+".text=\""+(c_var.name)+" = TRUE\" else chk_"+currid+".text=\""+(c_var.name)+" = FALSE\" \n"
					--ui_controls += "all_toolsets[santexToolbox.ddl_toolset.selection].tools["+(j as string)+"].vars["+(i as string)+"].value=val"
					--ui_controls += " )\n"
				)
			)
			
			ui_controls += "on subRolloutCtrl_"+curr_tool.id+" open do\n(\n"
			ui_controls += ui_add_later
			ui_controls += " )\n"
			
			ui_controls += ")\n"
			
			local rolled_up=false
			if(show_num)do rolled_up=true
			if(santexToolbox_ui_chk_opened)do rolled_up=false
			
			if(handlers_count>0) do
				ui_controls += "addSubRollout santexToolbox_eval.subRollouts subRolloutCtrl_"+curr_tool.id+" rolledUp:"+(rolled_up as string)+"\n"
			return ui_controls
	)
fn create_ui_controls current_tool included_tools=
(
	local ui_controls = ""
	local ui_add_later = ""
	local handlers_count = 0
		if (current_tool.vars.count>0)then
		(
			
			ui_controls += create_ui_register_globals current_tool
			ui_controls += create_ui_cotrols_for current_tool (santexToolbox.lbx_tools.selection) false 0
			for i=1 to included_tools.count do
			(
				ui_controls += create_ui_register_globals included_tools[i]
			)
			for i=1 to included_tools.count do
			(
				ui_controls += create_ui_cotrols_for included_tools[i] (santexToolbox.lbx_tools.selection+i) true i
			)
			
			
				
		)else
		(
			if(included_tools.count>0)do
			(
				for i=1 to included_tools.count do
				(
					ui_controls += create_ui_register_globals included_tools[i]
				)
				for i=1 to included_tools.count do
				(
					ui_controls += create_ui_cotrols_for included_tools[i] (santexToolbox.lbx_tools.selection+i) true i
				)
			)
		)
		--print ui_controls
		return ui_controls
	)