global santexSandbox1

global maintitle="santexSandbox1"
global copyright="(c)2013-2014 by santex"
global cfgdir=((getdir #maxroot)+"plugcfg\\santexTools\\santexSandbox1\\")
global configfile=(cfgdir+maintitle+".cfg")
global devlogfile=(cfgdir+maintitle+".log")
global fatalerror=false
global memory_allocation=35000000

struct strings_system
(
	init="Initializing...",
	close="Closing script...",
	loadScript="Evaluating script..."
)
struct strings_tt_struct
(
	projects="SCRIPTS",
	btn_select_project="Run selected script",
	btn_close_project="Close running script",
	btn_view2d3d="Toggle between 2D and 3D view",
	btn_settings="Open settings",
	btn_exit="Exit",
	system=strings_system()
)
struct strings_struct
(
	projects="SCRIPTS",
	btn_select_project="RUN",
	btn_close_project="CLOSE",
	btn_view2d3d="3D",
	btn_settings="...",
	btn_exit="X",
	strings_tt=strings_tt_struct(),
	system=strings_system()
)
global strings=strings_struct()

fn clearAllVars=
(
	--strings=undefined
)
fn mUI_addSubRollout subroll=
(
	--printlog type:3 txt:("plasmacutter_ui.ms > mUI_addSubRollout "+subroll as string+"")
	
	try(addSubRollout santexSandbox1.subRollouts subroll rolledUp:false)catch()--printlog type:4 txt:("mUI_addSubRollout ("+subroll as string+")"))
)
fn mUI_delSubRollout subroll=
(
	--printlog type:3 txt:("plasmacutter_ui.ms > mUI_delSubRollout "+subroll as string+"")
	
	try(
		removeSubRollout santexSandbox1.subRollouts subroll
		return true
	)catch(
		--printlog type:4 txt:("mUI_delSubRollout ("+subroll as string+")")
		return false
	)
)

fn resetview_2d=
(
	--printlog type:3 txt:("plasmacutter_fn-views.ms > resetview_2d()")
	
	viewport.ResetAllViews()
	max zoomext sel all
	max vpt top
	max wire smooth
	max grid toggle
	max tool maximize
	max zoomext sel all
	actionMan.executeAction 0 "370"
	--if (sheet_ghost!=undefined) then hide sheet_ghost
	view_is_in="2d"
)

fn resetview_3d=
(
	--printlog type:3 txt:("plasmacutter_fn-views.ms > resetview_3d()")
	
	viewport.ResetAllViews()
	max wire smooth
	max grid toggle
	max tool maximize
	max zoomext sel all
	actionMan.executeAction 0 "370"
	-- F3 and F4
	actionMan.executeAction 0 "272"  -- Views: Wireframe / Smooth+Highlights Toggle
	--max wire smooth
	--actionMan.executeAction 0 "369"  -- turn off wireframe
	
	--if (sheet_ghost!=undefined) then unhide sheet_ghost
	view_is_in="3d"
)