global santexToolbox_create_adv

rollout santexToolbox_create_adv "Advanced settings" width:200 height:100
(
	label lbl0 ""
	checkbox chk_internal "This tool is 'internal'" tooltip:"Tool is used by other tools only/mostly. (It will be hidden in tools list if 'Hide internal' is enabled"
	checkbox chk_hide_ctrl "Don't show UI controls" tooltip:"UI controls will be hidden for this tool during execution (evaluation) time"
	checkbox chk_locked "This tool is 'locked'" tooltip:"This tool will be unchangeable during execution (evaluation) time"
	
	--button btn_cancel "Close" width:80 height:32 pos:[240,160]
	
	--on btn_cancel pressed do destroydialog santexToolbox_create_adv
	on santexToolbox_create_adv open do
	(
		if(santexToolbox.lbx_tools.selection>0)do
		(
			local adv_setts = all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].adv_setts
			chk_internal.checked = adv_setts.internal
			chk_hide_ctrl.checked = adv_setts.hide_ctrl
			chk_locked.checked = adv_setts.locked
		)
	)
	on santexToolbox_create_adv close do
	(
		if(santexToolbox.lbx_tools.selection>0)do
		(
			local adv_setts = adv_setts_struct internal:chk_internal.checked\
															hide_ctrl:chk_hide_ctrl.checked\
															locked:chk_locked.checked
			--print more_options1
			all_toolsets[santexToolbox.ddl_toolset.selection].tools[santexToolbox.lbx_tools.selection].adv_setts = adv_setts
		)
	)
)
createdialog santexToolbox_create_adv