global santexToolbox_show_details

rollout santexToolbox_show_details "Details" width:680 height:220
(
	local cfgdir=((getdir #maxroot)+"plugcfg\\santexTools\\santexToolbox\\")
	
	label lbl0 ""
	label lbl1 "" width:660
	label lbl2 "" width:660
	label lbl5 "" width:660
	label lbl3 "" width:660 height:32
	label lbl4 ""
	label lbl8 "" width:660 height:28
	label lbl6 "" width:660
	label lbl7 "" width:660
	
	button btn_open_loc "Open folder" pos:[550,170] width:120 enabled:false
	button btn_delete "Delete this Toolset" pos:[550,40] width:120 enabled:false visible:true
	
	include "santex_fnlib.ms"
	
	fn getInternalCount tools=
	(
		local internal_count =0
		if(tools.count>0)do
		(
			for i=1 to tools.count do
			(
				if(tools[i].adv_setts.internal == true) do internal_count += 1
			)
		)
		return internal_count
	)
	
	on btn_delete pressed do
	(
		if (querybox "Do you really want to delete this Toolset?" title:"santexToolbox")do
		(
			destroydialog santexToolbox_show_details
			slib.workDlg.open()
			slib.workDlg.job "Loading tools ..."
			local filename = all_toolsets[santexToolbox.ddl_toolset.selection].dir + "-toolset.ini" 
			deleteFile (cfgdir + all_toolsets[santexToolbox.ddl_toolset.selection].dir  + "\\" + filename)
			--print (cfgdir + all_toolsets[santexToolbox.ddl_toolset.selection].dir  + "\\" + filename)
			--str = "rmDir C:\\doscmdtest\\"
			--hiddendoscommand str startpath:"$max" exitCode:&exitcode
			
			santexToolbox.refresh_toolset_list()
			slib.workDlg.close()
		)
	)
	on btn_open_loc pressed do
	(
		shelllaunch (cfgdir + all_toolsets[santexToolbox.ddl_toolset.selection].dir) ""
	)
	on santexToolbox_show_details open do
	(
		if(santexToolbox.ddl_toolset.selection>0) do
		(
			santexToolbox_show_details.title = ("santexToolbox: Details of '" + all_toolsets[santexToolbox.ddl_toolset.selection].name + "' toolset")
			
			lbl1.text = "Name: " + all_toolsets[santexToolbox.ddl_toolset.selection].name
			lbl2.text = "Author: " + all_toolsets[santexToolbox.ddl_toolset.selection].author
			lbl3.text = "Description: " + all_toolsets[santexToolbox.ddl_toolset.selection].desc
			
			local cfgdir=((getdir #maxroot)+"plugcfg\\santexTools\\santexToolbox\\")
			lbl8.text = "Tools directory: " + (cfgdir + all_toolsets[santexToolbox.ddl_toolset.selection].dir + "\\")
			lbl5.text = "Date created: " + all_toolsets[santexToolbox.ddl_toolset.selection].created
			lbl6.text = "Total number of tools: " + all_toolsets[santexToolbox.ddl_toolset.selection].tools.count as string
			
			local internal_tools_count = getInternalCount (all_toolsets[santexToolbox.ddl_toolset.selection].tools)
			lbl7.text = "Number of 'internal' tools: " + internal_tools_count as string
			
			btn_open_loc.enabled=btn_delete.enabled=true
		)
	)
)
createdialog santexToolbox_show_details modal:true